/* ************************************************************************** */
/*                                                                            */
/*  addin.ld                                                                  */
/*  | Project : CaphiOS                                                       */
/*                                                                            */
/*  By: Lephenixnoir                                                          */
/*  Last updated: 2016/05/26 08:15:28                                         */
/*                                                                            */
/* ************************************************************************** */

OUTPUT_ARCH(sh3)
ENTRY(_start)

MEMORY {
	rom	: o = 0x00300200, l = 512k
	ram	: o = 0x08100000, l = 64k
}

SECTIONS {
	/*
	**	ROM sections :
	**	Binary code and read-only data.
	*/
	.text : {
		/* Initialization code. */
		*(.pretext)
		*(.pretext.*)

		/* Constructors and destructors */
		_bctors = . ; /* Begin */
		*(.ctors)
		_ectors = . ; /* End */
		_bdtors = . ; /* Begin */
		*(.dtors)
		_edtors = . ; /* End */

		/* Text */
		*(.text)
		*(.text.*)
	} > rom

	.rodata : {
		*(.rodata)
		*(.rodata.*)

		_romdata = ALIGN(4) ;
	} > rom

	/*
	**	RAM sections :
	**	BSS and read/write data.
	**	The BSS section is meant to be stripped from the ELF file (to reduce
	**	binary size) and initialized with zeros in the initialization routine,
	**	therefore its location is undefined.
	*/
	.bss : {
		/* BSS */
		_bbss = . ; /* Begin */
		*(.bss)
		_ebss = . ; /* End */
	} > ram

	.data : AT(_romdata) ALIGN(4) {
		_bdata = . ; /* Begin */
		*(.data)
		*(.data.*)
		_edata = . ; /* End */
	} > ram
}
