/* ************************************************************************** */
/*                                       _____           _                    */
/*  librtc/compiler.h                   |_   _|__  _   _| |__   ___ _   _     */
/*  | Project : librtc                    | |/ _ \| | | | '_ \ / _ \ | | |    */
/*                                        | | (_) | |_| | | | |  __/ |_| |    */
/*  By: thomas <thomas@touhey.fr>         |_|\___/ \__,_|_| |_|\___|\__, |.fr */
/*  Last updated: 2016/05/25 12:20:39                               |___/     */
/*                                                                            */
/* ************************************************************************** */
/*	This program is free software: you can redistribute it and/or modify
**	it under the terms of the GNU General Public License as published by
**	the Free Software Foundation, either version 3 of the License, or
**	(at your option) any later version.
**
**	This program is distributed in the hope that it will be useful,
**	but WITHOUT ANY WARRANTY; without even the implied warranty of
**	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**	GNU General Public License for more details.
**
**	You should have received a copy of the GNU General Public License
**	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef LIBRTC_COMPILER_H
# define LIBRTC_COMPILER_H

/*
**	Based on GCC attributes
*/

# ifndef __inline
#  define __inline __attribute__((always_inline, unused))
# endif
# ifndef __const
#  define __const __attribute__((const))
# endif
# ifndef __nonnull
#  define __nonnull __attribute__((nonnull(N)))
# endif
# ifndef __wur
#  define __wur __attribute__((warn_unused_result))
# endif

# ifndef __THROW
#  if defined __cplusplus
#   define __THROW __attribute__((nothrow))
#  else
#   define __THROW
#  endif
# endif

#endif /* LIBRTC_COMPILER_H */
