/* ************************************************************************** */
/*                                       _____           _                    */
/*  librtc/internals/bcd.h              |_   _|__  _   _| |__   ___ _   _     */
/*  | Project : librtc                    | |/ _ \| | | | '_ \ / _ \ | | |    */
/*                                        | | (_) | |_| | | | |  __/ |_| |    */
/*  By: thomas <thomas@touhey.fr>         |_|\___/ \__,_|_| |_|\___|\__, |.fr */
/*  Last updated: 2016/05/24 19:37:00                               |___/     */
/*                                                                            */
/* ************************************************************************** */
/*	This program is free software: you can redistribute it and/or modify
**	it under the terms of the GNU General Public License as published by
**	the Free Software Foundation, either version 3 of the License, or
**	(at your option) any later version.
**
**	This program is distributed in the hope that it will be useful,
**	but WITHOUT ANY WARRANTY; without even the implied warranty of
**	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**	GNU General Public License for more details.
**
**	You should have received a copy of the GNU General Public License
**	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef LIBRTC_INTERNALS_BCD_H
# define LIBRTC_INTERNALS_BCD_H
# include <librtc/internals.h>

# define intofbcd8(B) __intofbcd8(B)
static __inline int __intofbcd8(_bcd8_t b)
{
	return (b.d.dg2 * 10 + b.d.dg1);
}

# define intofbcd16(B) __intofbcd16(B)
static __inline int __intofbcd16(_bcd16_t b)
{
	return (b.d.dg4 * 1000 + b.d.dg3 * 100 + b.d.dg2 * 10 + b.d.dg1);
}

# define bcd8ofint(I) __bcd8ofint(I)
static __inline _bcd8_t __bcd8ofint(int n)
{
	return (_bcd8_t){
		.raw = ((n / 10) << 4) | (n % 10)
	};
}

# define bcd16ofint(I) __bcd16ofint(I)
static __inline _bcd16_t __bcd16ofint(int n)
{
	return (_bcd16_t){
		.raw = ((n / 1000) << 12) | ((n / 100 % 10) << 8)
			| ((n / 10 % 10) << 4) | (n % 10)
	};
}

#endif /* LIBRTC_INTERNALS_BCD_H */
