/* ************************************************************************** */
/*                                       _____           _                    */
/*  librtc/internals/bswp.h             |_   _|__  _   _| |__   ___ _   _     */
/*  | Project : librtc                    | |/ _ \| | | | '_ \ / _ \ | | |    */
/*                                        | | (_) | |_| | | | |  __/ |_| |    */
/*  By: thomas <thomas@touhey.fr>         |_|\___/ \__,_|_| |_|\___|\__, |.fr */
/*  Last updated: 2016/05/24 19:36:47                               |___/     */
/*                                                                            */
/* ************************************************************************** */
/*	This program is free software: you can redistribute it and/or modify
**	it under the terms of the GNU General Public License as published by
**	the Free Software Foundation, either version 3 of the License, or
**	(at your option) any later version.
**
**	This program is distributed in the hope that it will be useful,
**	but WITHOUT ANY WARRANTY; without even the implied warranty of
**	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**	GNU General Public License for more details.
**
**	You should have received a copy of the GNU General Public License
**	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef LIBRTC_INTERNALS_BSWP_H
# define LIBRTC_INTERNALS_BSWP_H
# include <librtc/internals.h>

# define uint8bswp(N) __uint8bswp(N)
static __inline unsigned int __uint8bswp(unsigned int n)
{
	n = n >> 4 | n << 4;
	n = (n & 0xCC) >> 2 | (n & 0x33) << 2;
	n = (n & 0xAA) >> 1 | (n & 0x55) << 1;
	return (n);
}

#endif /* LIBRTC_INTERNALS_BSWP_H */
