/* ************************************************************************** */
/*                                       _____           _                    */
/*  adjustwday.c                        |_   _|__  _   _| |__   ___ _   _     */
/*  | Project : librtc                    | |/ _ \| | | | '_ \ / _ \ | | |    */
/*                                        | | (_) | |_| | | | |  __/ |_| |    */
/*  By: thomas <thomas@touhey.fr>         |_|\___/ \__,_|_| |_|\___|\__, |.fr */
/*  Last updated: 2016/07/19 08:59:30                               |___/     */
/*                                                                            */
/* ************************************************************************** */
/*	This program is free software: you can redistribute it and/or modify
**	it under the terms of the GNU General Public License as published by
**	the Free Software Foundation, either version 3 of the License, or
**	(at your option) any later version.
**
**	This program is distributed in the hope that it will be useful,
**	but WITHOUT ANY WARRANTY; without even the implied warranty of
**	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**	GNU General Public License for more details.
**
**	You should have received a copy of the GNU General Public License
**	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <librtc/internals.h>

/*
**	rtc_adjustwday:
**	Adjust week day with the rest of the date with Zeller formula.
**	@date: pointer on date
*/

void rtc_adjustwday(rtc_date_t *date)
{
	int month = date->month, year = date->year;
	if (month <= 2) {
		month = (month - 1) ? 14 : 13;
		year--;
	}
	int century = year / 100;
	year %= 100;
	int wday = date->day + 13 * (month + 1) / 5 + year + (year / 4)
		+ century / 4 + 5 * century;
	date->wday = ((wday + 7 - 1) % 7);
}
