/* ************************************************************************** */
/*                                       _____           _                    */
/*  setdate.c                           |_   _|__  _   _| |__   ___ _   _     */
/*  | Project : librtc                    | |/ _ \| | | | '_ \ / _ \ | | |    */
/*                                        | | (_) | |_| | | | |  __/ |_| |    */
/*  By: thomas <thomas@touhey.fr>         |_|\___/ \__,_|_| |_|\___|\__, |.fr */
/*  Last updated: 2016/05/24 19:23:27                               |___/     */
/*                                                                            */
/* ************************************************************************** */
/*	This program is free software: you can redistribute it and/or modify
**	it under the terms of the GNU General Public License as published by
**	the Free Software Foundation, either version 3 of the License, or
**	(at your option) any later version.
**
**	This program is distributed in the hope that it will be useful,
**	but WITHOUT ANY WARRANTY; without even the implied warranty of
**	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**	GNU General Public License for more details.
**
**	You should have received a copy of the GNU General Public License
**	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <librtc/internals/bcd.h>
#include <librtc/internals/bswp.h>

/*
**	rtc_setdate:
**	Set date in RTC.
*/

void rtc_setdate(rtc_date_t date)
{
	// halt RTC
	_rtc_cr2->c.START = 0;

	// set RTC fields
	_rtc_cnt->hz64 = (uint8bswp(date.hz64) >> 1);
	_rtc_cnt->sec = bcd8ofint(date.sec);
	_rtc_cnt->min = bcd8ofint(date.min);
	_rtc_cnt->hour = bcd8ofint(date.hour);
	_rtc_cnt->wday = bcd8ofint(date.wday);
	_rtc_cnt->day = bcd8ofint(date.day);
	_rtc_cnt->month = bcd8ofint(date.month);
	_rtc_cnt->year = bcd16ofint(date.year);

	// restart RTC
	_rtc_cr2->c.START = 1;
}
